/* Random simple tests of the AA library */

#include <ioprotos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <flt.h>
#include <ia.h>
#include <aa.h>

/*** INTERNAL PROTOTYPES ***/

int main(int argc, char *argv[]);

void aa_test_inv(void);
void aa_test_div(void);

/*** MAIN PROGRAM ***/

int main(int argc, char *argv[])
  {
    flt_init();
    ia_init();
    aa_init();
  
    aa_test_inv();
    aa_test_div();
    return (0);
  }

void aa_test_inv(void)
  {
    MemP frame = aa_top();
    Interval xi = (Interval){3,4};
    AAP xa = aa_from_interval(xi);
    AAP za;
    za = aa_inv(xa);
    fprintf(stderr,"x = "); aa_print(stderr,xa); fprintf(stderr,"\n");
    fprintf(stderr,"z = "); aa_print(stderr,za); fprintf(stderr,"\n");
    aa_flush(frame);
  }

void aa_test_div(void)
  {
    MemP frame = aa_top();
    Interval xi = (Interval){1,1};
    Interval yi = (Interval){3,4};
    AAP xa = aa_from_interval(xi);
    AAP ya = aa_from_interval(yi);
    AAP za;
    za = aa_div(xa,ya);
    fprintf(stderr,"x = "); aa_print(stderr,xa); fprintf(stderr,"\n");
    fprintf(stderr,"y = "); aa_print(stderr,ya); fprintf(stderr,"\n");
    fprintf(stderr,"z = "); aa_print(stderr,za); fprintf(stderr,"\n");
    aa_flush(frame);
  }
