/* iatimes.c - timing of IA operations */
/* Last edited on 2007-01-04 00:14:59 by stolfi */

#include <ia.h>
#include <flt.h>
#include <ioprotos.h>
#include <stdio.h>
#include <timefunc.h>

/* int ieee_flags(char *a, char *b, char *c, char **out); */

int main (void);

int do_empty(int ntimes);
int do_ia_add(int ntimes);
int do_ia_mul(int ntimes);

#define NTIMES 10000000

int main (void)
  {
    ia_init();
    
    time_func("empty loop",     do_empty,       NTIMES);
    time_func("ia_add",         do_ia_add,      NTIMES);
    time_func("ia_mul",         do_ia_mul,      NTIMES);
    return(0);
  }
    
int do_empty(int ntimes)
  { int i;
    for (i=0; i<ntimes; i++) { /* do nothing */ }
    return (ntimes);
  }
 
int do_ia_add(int ntimes)
  { int i;
    Interval x = (Interval){flt_random()-0.5, flt_random()+0.5};
    Interval y = (Interval){flt_random()-0.5, flt_random()+0.5};
    Interval z;
    for (i=0; i<ntimes; i++)
      { z = ia_add(x, y);
        z = ia_add(x, y);
        z = ia_add(x, y);
        z = ia_add(x, y);
        z = ia_add(x, y);
        z = ia_add(x, y);
        z = ia_add(x, y);
        z = ia_add(x, y);
        z = ia_add(x, y);
        z = ia_add(x, y);
      }
    return (10*ntimes);
  }
    
int do_ia_mul(int ntimes)
  { int i;
    Interval x = (Interval){flt_random()-0.5, flt_random()+0.5};
    Interval y = (Interval){flt_random()-0.5, flt_random()+0.5};
    Interval z;
    for (i=0; i<ntimes; i++)
      { z = ia_mul(x, y);
        z = ia_mul(x, y);
        z = ia_mul(x, y);
        z = ia_mul(x, y);
        z = ia_mul(x, y);
        z = ia_mul(x, y);
        z = ia_mul(x, y);
        z = ia_mul(x, y);
        z = ia_mul(x, y);
        z = ia_mul(x, y);
      }
    return (10*ntimes);
  }
    

