/* See timefunc.h */
/* Last edited on 2007-01-13 21:36:10 by stolfi */

#include <jstime.h>
#include "timefunc.h"
#include <stdio.h>

int timefunc_do_empty(int ntimes);

void time_func (
    char *title,
    int (*func) (int ntimes),
    int ntimes
  )
  {   
    double start, stop, tare;
    int actual_ntimes;
    
    /* Time an empty loop, to discount... */
    start = user_cpu_time_usec();
    (void) timefunc_do_empty(ntimes);
    stop = user_cpu_time_usec();
    tare = stop-start;

    /* Now time the function itself: */
    start = user_cpu_time_usec();
    actual_ntimes = func(ntimes);
    stop = user_cpu_time_usec();
    fprintf(stderr, "times for %s:\n", title);
    fprintf(stderr, "  total iterations = %d\n", actual_ntimes);
    fprintf(stderr, "  start clock (ms) = %.0f\n", start/1000.0);
    fprintf(stderr, "  stop clock (ms) =  %.0f\n", stop/1000.0);
    fprintf(stderr, "  total time (ms) =  %.0f\n", (stop-start)/1000.0);
    fprintf(stderr, "  overhead (ms) =    %.0f (%.1f%%)\n", 
      tare/1000.0, 100*tare/(stop-start+0.00001)
    );
    fprintf(stderr, "  average us/call =  %.4f\n", 
      (stop-start-tare)/((double)actual_ntimes)
    );
  }

int timefunc_do_empty(int ntimes)
  { int i;
    for (i=0; i<ntimes; i++) { /* do nothing */ }
    return (ntimes);
  }
 
