/* Access to the PSWriter associated to a Postscript file */
/* Last edited on 2003-09-30 05:49:32 by stolfi */

#ifndef ps_compat_H
#define ps_compat_H

/* 
  This module is an extension of {ps.h}. It gives access to the
  {PSStream} associated to a Postscript file. Its purpose is to allow
  a more gradual upgrade of programs that used the old "ps.h"
  interface to the new "pswr.h" interface. */

#include <ps.h>
#include <pswr.h>
#include <stdio.h>

PSStream *ps_get_stream(FILE *psfile);
  /* Gets the current PS stream for file {psfile}. The file must have
    been initialized with {ps_begin_document} or ps_begin_figure. */

#endif
