#ifndef zf_aa_H
#define zf_aa_H

/* Extension of {zf.h} for affine arithmetic. */
/* Last edited on 2007-02-15 23:27:18 by stolfi */

#include <ia.h>
#include <ia_trapez.h>
#include <aa.h>
#include <zf.h>

ia_trapez_t zf_trapezoid_from_aa(Interval *xr, AAP xf, AAP yf);
  /* Converts an AA graph enclosure into a {ia_trapez_t}.
    Namely, returns a trapezoid {tr} that encloses 
    the joint range of the affine forms {xf,yf},
    clipped to the vertical band whose X projection
    is {xr}. The centroid of {xf} must be inside {xr}. */

#endif
