/* 
 * File:   cfChangeSign.cpp
 * Author: Mario J. Martin <dominonurbs$gmail.com>
 *
 */


#include "cf_definitions.hpp"


/** Changes the sign bit */
template< unsigned int M, unsigned int E >
static inline CustomFloat< M, E > cfChangeSign(const CustomFloat< M, E >& u)
{
	man_t m;

	if ( (u.m & CustomFloat< M, E >::MASK_SIGN_BIT) != 0){
		m = u.m & CustomFloat< M, E >::MASK_MANTISSA;
	}
	else{
		m = u.m | CustomFloat< M, E >::MASK_SIGN_BIT;
	}

	return CustomFloat< M, E >(m, u.e);
}

