/* 
 * File:   cfToString.cpp
 * Author: Mario J. Martin <dominonurbs$gmail.com>
 *
 */

#include "cf_definitions.hpp"


/** utility function to visualize bits of a mantissa */
static char* cfToString(const man_t value)
{
	static char cf_buffer_string[sizeof(man_t) * 8 + 1];

	for (int i = sizeof(man_t) * 8 - 1; i >= 0; i--){
		man_t mask = 1;
		mask <<= i;
		if ((value & mask) != 0)
			cf_buffer_string[sizeof(man_t) * 8 - i - 1] = '1';
		else
			cf_buffer_string[sizeof(man_t) * 8 - i - 1] = '0';
	}
	
	cf_buffer_string[sizeof(man_t) * 8] = 0;
	
	return cf_buffer_string;
}

/** utility function to visualize bits of a exponent */
static char* cfToString(const exp_t value)
{
	long m = value;
	static char cf_buffer_string[sizeof(exp_t) * 8 + 1];

	for (int i = sizeof(exp_t) * 8 - 1; i >= 0; i--){
		man_t mask = 1;
		mask <<= i;
		if ((m & mask) != 0)
			cf_buffer_string[sizeof(exp_t) * 8 - i - 1] = '1';
		else
			cf_buffer_string[sizeof(exp_t) * 8 - i - 1] = '0';
	}
	
	cf_buffer_string[sizeof(exp_t) * 8] = 0;
	
	return cf_buffer_string;
}

/** utility function to visualize bits of a CustomFlotat exponent[sign]mantissa */
template< unsigned int M, unsigned int E >
static char* cfToString(CustomFloat< M, E > u)
{
	static char cf_buffer_string[M + E + 2];

	int ic = 0;

	for (int i = E - 1; i >= 0; i--){
		man_t mask = 1;
		mask <<= i;
		if ((u.e & mask) != 0)
			cf_buffer_string[ic++] = '1';
		else
			cf_buffer_string[ic++] = '0';
	}

	if ((u.m & CustomFloat< M, E >::MASK_SIGN_BIT) != 0)
		cf_buffer_string[ic++] = '-';
	else
		cf_buffer_string[ic++] = '+';

	for (int i = M - 1; i >= 0; i--){
		man_t mask = 1;
		mask <<= i;
		if ((u.m & mask) != 0)
			cf_buffer_string[ic++] = '1';
		else
			cf_buffer_string[ic++] = '0';
	}

	cf_buffer_string[M + E + 1] = 0;
	
	return cf_buffer_string;
}

