/* 
 * File:   cf_definitions.cpp
 * Author: Mario J. Martin <dominonurbs$gmail.com>
 *
 * Here is where the mantissa and exponent variable types 
 * and some parameters are defined.
 */

#ifndef _CF_DEFINITONS_
#define _CF_DEFINITONS_

/* Change the types used for represent the mantissa and the exponent here 
*  The exponent must be integral signed type
*  while the mantissa is recomended to be an unsigned type: 
*  char, short, int, long and long long */
/**********************/
typedef unsigned long man_t;	// type used to store the mantise value
typedef short exp_t;			// type used to store the exponent value
/**********************/

// Set to make the application to throw exceptions. 
#undef CF_THROW_ERRORS	

// Set to make the application to check for overflow. I could reduce the performance.
#define CF_CHECK_OVERFLOW




/* pre-declaration */
template< unsigned int M, unsigned int E > class CustomFloat;

// macro used to handle information on error, expanded with information about the file and line.
#define _cf_handle_error_(...) printf(__VA_ARGS__); printf("\nline: %d  file: %s ", __LINE__, __FILE__); 


#endif /* _CF_DEFINITONS_ */




